/*
 * Copyright (c) 2023 Xilinx
 * This package is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This package is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this package; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifndef __GST_XRM_H__
#define __GST_XRM_H__

#include <glib.h>

#include <xmaencoder.h>
#include <xmascaler.h>

G_BEGIN_DECLS

#define GST_XRM_ERROR -1

typedef struct _GstXrm GstXrm;

guint32 gst_xrm_choose_device (guint32 requested_device);

GstXrm * gst_xrm_reserve_enc_resources (gint device_id, gint* slice,
    const XmaEncoderProperties *props);

GstXrm * gst_xrm_reserve_dec_resources (gint device_id, gint width,
    gint height, gint fps_num, gint fps_den);

GstXrm * gst_xrm_reserve_scaler_resources (gint device_id,
    XmaScalerProperties * props);

void gst_xrm_free (GstXrm *self);

void gst_xrm_init ();

G_END_DECLS

#endif /* __GST_XRM_H__ */
